package com.example.sendbroadcast;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import android.app.Application;
import android.app.Service;
import android.app.Activity;
import android.content.Intent;
import android.content.Context;
import android.content.IntentFilter;
import android.util.Log;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;

/** SendbroadcastPlugin */
public class SendbroadcastPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  private MethodChannel receiver;
  private Context context;
  private MyBroadcastReceiver MyReceiver;
  private Result result;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "sendbroadcast");
    receiver = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "broadcastReceiver");
    channel.setMethodCallHandler(this);
    context = flutterPluginBinding.getApplicationContext();
    
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("sendBroadcast")){
      final String value = call.argument("message");
      final String action = call.argument("action");
      final String param = call.argument("param");
      Intent intent = new Intent(action);
      intent.putExtra(param,value);
      context.sendBroadcast(intent);
      result.success(value);
    } else if(call.method.equals("RegisterBroadcast")) {
      Log.i("BR" ,"reveiveBroadcast");
      if(MyReceiver != null){
         context.unregisterReceiver(MyReceiver);
      }
      final String action = call.argument("action");
      final String param = call.argument("param");
      MyReceiver = new MyBroadcastReceiver();
      MyReceiver.channel = receiver;
      MyReceiver.param = param;
      IntentFilter intentFilter = new IntentFilter(action);
      if(intentFilter != null)
      {
          Log.i("BR" ,"registerReceiver");
         context.registerReceiver(MyReceiver, intentFilter);
      }
    } else {
      result.notImplemented();
    }
  }



  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
     if(MyReceiver != null)
               context.unregisterReceiver(MyReceiver);
  }
}
