import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:sendbroadcast/sendbroadcast.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    // initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.

  final sendBroadcast = SendBroadcast();

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Column(
          children: [
            Center(
              child: ElevatedButton(
                  onPressed: () async {
                    await sendBroadcast.registerReceiver(
                        action: "NEW_NEW", param: "message");
                  },
                  child: const Text("registerReceiver")),
            ),
            Center(
              child: ElevatedButton(
                  onPressed: () async {
                    // await SendBroadcast.send2('NEW_NEW');
                    await sendBroadcast.send(
                        value: 'asdasdsadasdas',
                        action: 'NEW_NEW',
                        param: 'message');
                    setState(() {});
                  },
                  child: const Text("send")),
            ),
          ],
        ),
      ),
    );
  }
}
