import 'dart:async';
import 'dart:developer';

import 'package:flutter/services.dart';

class SendBroadcast {
  final receive = const MethodChannel("broadcastReceiver");
  final MethodChannel _channel = const MethodChannel('sendbroadcast');
  late Future<void> Function(String) _mainProcess;
  SendBroadcast() {
    receive.setMethodCallHandler(nativeMethodCallHandler);
  }

  Future<void> registerCallBack(
      Future<void> Function(String) mainProcess) async {
    _mainProcess = mainProcess;
  }

  Future<String> send({
    required String value,
    required String action,
    required String param,
  }) async {
    final res = await _channel.invokeMethod('sendBroadcast', {
      "message": value,
      "action": action,
      "param": param,
    });
    return res;
  }

  Future<String> registerReceiver({
    required String action,
    required String param,
  }) async {
    final res = await _channel.invokeMethod('RegisterBroadcast', {
      "action": action,
      "param": param,
    });
    return res;
  }

  Future<dynamic> nativeMethodCallHandler(MethodCall methodCall) async {
    switch (methodCall.method) {
      case "received":
        await _mainProcess(methodCall.arguments.toString());
        break;
      default:
        break;
    }
  }
}
